
#    Note:  This is loaded into the namespace  MASTERTS

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    for {set i 0} {$i <= 8} {incr i} {variable Opt$i 0}


   proc  show_variables {} {
       variable allmodules 

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }

   proc do_redisplay {} {

     WriteAIDARegister 0x412 0   ;# write to copy timestamp 
     for {set i 0} {$i <= 8} {incr i} {
        variable Opt$i
        set Opt$i [ReadAIDARegister [expr 0x410 + $i]]
     }
   }

   proc do_setOpt {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x410 + $i] $vl
      }

      set ::AIDA::FEE64 $BAK   ;#  restore
   }

   proc ReSYNC {} {
     variable allmodules

     if {[llength $::AIDA::ModuleMenu] == 1} {
        InsertLog "ReSYNC not requested since only 1 module"
        InsertLog "ReSYNC must be performed from global control server"
        return
     }

     InsertLog "Performing timestamp ReSYNC..."

      set MTime 0

      set BAK $::AIDA::FEE64    ;#   save

      set ::AIDA::FEE64 $::AIDA::TSMaster   ;# select Master 

            WriteAIDARegister 0x412 0            ;# write to copy timestamp 
            set MTimeH [ReadAIDARegister 0x413]   ;# read timestamp high 32 bits
            set MTimeL [ReadAIDARegister 0x412]   ;# read timestamp low 32 bits

            InsertLog "Current master timestamp from $::AIDA::FEE64 is $MTimeH $MTimeL"

            if {[expr ($MTimeL >> 28) & 0xf] >= 0xe} {
                set NewTimeL 0
                set NewTimeH [format 0x%08x [expr $MTimeH + 1]]
            } else {
                set NewTimeL [format 0x%08x [expr ($MTimeL & 0xf0000000) + 0x20000000]]
                set NewTimeH $MTimeH
            }

            WriteAIDARegister 0x417 $NewTimeL    ;#   load timestamp used by master to generate ReSYNC pulse
            WriteAIDARegister 0x418 $NewTimeH    ;# 

            WriteAIDARegister 0x410 9        ;#   master generates RESYNC request

            InsertLog "ReSync at time $NewTimeH $NewTimeL"

      set ::AIDA::FEE64 $BAK    ;# restore

#    set RESYNC in all modules

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {

         set ::AIDA::FEE64 $fee64

         WriteAIDARegister 0x40a $NewTimeL    ;#   load timestamp used when ReSYNC pulse arrives
         WriteAIDARegister 0x40b $NewTimeH    ;# 

         WriteAIDARegister 0x400 9        ;#   slave generates RESYNC request
      }

      set ::AIDA::FEE64 $BAK

      InsertLog "All modules sent ReSync request"

#    check for ReSync complete

      set BAK $::AIDA::FEE64   ;#   save 

      set ::AIDA::FEE64 $::AIDA::TSMaster   ;# select Master 

#    check status from the master

      for {set i 0} {$i < 10} {incr i} {

         set STATUS [ReadAIDARegister 0x411]    ;#  Master timestamp status
         if {$STATUS == 0x1} {
             InsertLog "Master ReSync done"
             break
         } else {
             after 1000  ;#  wait a bit longer
         }
      }

      if {$i == 10} {InsertLog "Warning: Master ReSync NOT complete"}

      set ::AIDA::FEE64 $BAK

#    check status from all slaves

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {

            set ::AIDA::FEE64 $fee64
 
            set STATUS [ReadAIDARegister 0x401]  ;#  timestamp status
            if {$STATUS == 0x1} {InsertLog "$::AIDA::FEE64 ReSync done"} else {InsertLog "Warning: $::AIDA::FEE64 ReSync NOT complete"}
      }

      set ::AIDA::FEE64 $BAK

#   remove ReSync request from everywhere

      set BAK $::AIDA::FEE64

      set ::AIDA::FEE64 $::AIDA::TSMaster   ;# select Master 
      WriteAIDARegister 0x410 1

      foreach fee64 $::AIDA::ModuleMenu {

         set ::AIDA::FEE64 $fee64
         WriteAIDARegister 0x400 1
      }

      set ::AIDA::FEE64 $BAK

      InsertLog "ReSync procedure complete"

  }

   proc do_ReSYNC {} {             ;# for remote execution from AIDA Control window
       variable JS

       set JS ""

       ReSYNC

      return "$JS"
  }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTS     {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




