
#    Note:  This is loaded into the namespace  RDOUT

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    for {set i 0} {$i <= 12} {incr i} {variable Opt600.$i 0}
    for {set i 0} {$i <= 14} {incr i} {variable Opt300.$i 0}
    for {set i 0} {$i <= 11} {incr i} {variable Opt500.$i 0}


   proc  show_variables {} {
       variable allmodules 

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"

       for {set i 0} {$i <= 12} {incr i} {variable Opt600.$i; InsertLog "600.$i = [set Opt600.$i]"}
       for {set i 0} {$i <= 14} {incr i} {variable Opt300.$i; InsertLog "300.$i = [set Opt300.$i]"}
       for {set i 0} {$i <= 11} {incr i} {variable Opt500.$i; InsertLog "500.$i = [set Opt500.$i]"}
   }

   proc do_redisplay {} {

     for {set i 0} {$i <= 10} {incr i} {
        variable Opt600.$i
        if {$i == 7} continue
        set Opt600.$i [ReadAIDARegister [expr 0x600 + $i]]
     }

     for {set i 0} {$i <= 14} {incr i} {
        variable Opt300.$i
        if {$i == 1} continue
        if {$i == 4 || $i == 5} continue
        if {$i == 8 || $i == 9 || $i == 10 || $i == 11} continue
        set Opt300.$i [ReadAIDARegister [expr 0x300 + $i]]
     }

     for {set i 0} {$i <= 11} {incr i} {
        variable Opt500.$i
        if {$i == 1} continue
        if {$i == 3 || $i == 4 || $i == 5} continue
        set Opt500.$i [ReadAIDARegister [expr 0x500 + $i]]
        if {$i == 0} {set Opt500.0 [expr [set Opt500.0] & 15]}  ;# until firmware tidy
     }
   }

   proc do_setOpt600 {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x600 + $i] $vl
      }

      set ::AIDA::FEE64 $BAK   ;#  restore
   }

   proc do_setOpt300 {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x300 + $i] $vl
      }

      set ::AIDA::FEE64 $BAK   ;#  restore
   }

   proc do_setOpt500 {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x500 + $i] $vl
      }

      set ::AIDA::FEE64 $BAK   ;#  restore
   }
 
   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTS300     {do_setOpt300 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   OPTS600     {do_setOpt600 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   OPTS500     {do_setOpt500 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




