
#    Note:  This is loaded into the namespace  AIDA_SaveRestore

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable DBNameList {"xxx"}
    variable DBName [first $DBNameList]

   variable index 0
   variable selected -1


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected
        variable DBName

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
        InsertLog "DBName=$DBName"
        foreach fee64 $::AIDA::ModuleMenu {InsertLog "$fee64"}

#        InsertLog "HasBeenConfigured = [ReadRegister HasBeenConfigured]"
#        InsertLog "HasBeenRestored = [ReadRegister HasBeenRestored]"
   }

      proc Selection {} {
          variable selected

          set selected 0

           set i 1
           foreach item $::AIDA::ModuleMenu {
               set selected [expr $selected | (1 << $i)]
               incr i
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }
  
      proc do_Save {} {
        variable selected

         if {$selected == 0} {Selection}
      
        InsertLog "Saving FEE64 settings to $::AIDA::DBRootName/$::AIDA::DBNodeBase"

        set BAK $::AIDA::FEE64   ;# save
        
           set i 1
           foreach fee64 $::AIDA::ModuleMenu {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             set ::AIDA::FEE64 $fee64
             Save_FEE64
             InsertLog "FEE64 settings saved for $::AIDA::FEE64"
             incr i
          }

        set ::AIDA::FEE64 $BAK    ;# restore

        InsertLog "FEE64 settings saved to $::AIDA::DBRootName/$::AIDA::DBNodeBase"

        Elog INFORMATION "FEE64 settings saved to $::AIDA::DBRootName/$::AIDA::DBNodeBase"

        do_DBUpdate
    }

      proc do_Restore {} {
        variable selected

         if {$selected == 0} {Selection}
      
        InsertLog "Restoring FEE64 settings from $::AIDA::DBRootName/$::AIDA::DBNodeBase"

        set BAK $::AIDA::FEE64
        
          set i 1
          foreach fee64 $::AIDA::ModuleMenu {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             set ::AIDA::FEE64 $fee64
             Restore_FEE64 
             InsertLog "FEE64 settings restored for $::AIDA::FEE64"
             incr i
          }

        set ::AIDA::FEE64 $BAK

        InsertLog "FEE64 settings restored from $::AIDA::DBRootName/$::AIDA::DBNodeBase"

#       ::AIDA::WriteRegister HasBeenRestored 1

        Elog INFORMATION "FEE64 settings restored from $::AIDA::DBRootName/$::AIDA::DBNodeBase"

        do_DBUpdate
    }

    proc Save_FEE64 {} {

      set m $::AIDA::FEE64

      for {set asic 1} {$asic < 5} {incr asic} {
         for {set i 0} {$i < 27} {incr i} {
            set vl [ReadAIDARegister [expr 0x4000 + (($asic-1)*64) + $i]]
            DBSetValue $m.$asic.$i [format "0x%02x" [expr $vl & 255]]
         }
      }
    }

    proc Restore_FEE64 {} {

      set m $::AIDA::FEE64

        for {set asic 1} {$asic < 5} {incr asic} {
           for {set i 0} {$i < 27} {incr i} {
              set vl [DBGetValue $m.$asic.$i]
              WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + $i]] $vl
           }
        }
   }

      proc do_DBName {vl} {
          variable DBName

          set DBName $vl
          set ::AIDA::DBNodeBase $DBName

          set node $::AIDA::DBRootName/$::AIDA::DBNodeBase
          DBCreateNode $node

          InsertLog "Data Base node $node contains [DBGetNodes $node *]"
      }

      proc do_DBUpdate {} {
          variable DBNameList

          set DBNameList [DBGetNodes $::AIDA::DBRootName *]
      }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                RESTORE  {do_Restore}
                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

   Selection

     do_DBUpdate
     do_DBName [lindex $DBNameList 0]


}  ;# end of if {$started == 0}

